// Global variables

function setImage( imageSrc )
{
 var image = new Image();
 image.src = imageSrc;
 
 return image;
}



var session = {}
session.user = {};
session.user.userId = 0;


var game = {};

game.numOfSelected = 0;
game.joinable           = {};

game.objectBoard        = [];
game.updatedTurnId      = null;

game.music=true;
game.mute="off";

game.bubbleCheckersOne = 0;
game.bubbleCheckersTwo = 0;

game.resume = null;
game.images = {};

game.newGame = null;

game.images.backgrounds = [];

game.images.square          = setImage("./img/square.png");
game.images.backgrounds[0]  = setImage("./img/background00.png");

game.images.boardBack = [];
game.images.boardBack[0] = setImage("./img/board-back00.png");

game.images.title           = setImage("./img/title.png");

game.images.checker01 = setImage("./img/checker01.png");
game.images.checker01change = setImage("./img/checker01-change.png");
game.images.checker01selected = setImage("./img/checker01-selected.png");
game.images.checker02 = setImage("./img/checker02.png");
game.images.checker02change = setImage("./img/checker02-change.png");
game.images.checker02selected = setImage("./img/checker02-selected.png");

game.images.font      = setImage("./img/font01.png");
game.images.fontSmall = setImage("./img/font03.png");
game.images.splash    = setImage("./img/onehourgroup01.png");

game.images.newGame   = setImage("./img/txtbutton-new-game.png");
game.images.joinGame  = setImage("./img/txtbutton-join-game.png");
game.images.accept    = setImage("./img/txtbutton-accept-game.png");
game.images.decline   = setImage("./img/txtbutton-decline-game.png");
game.images.cancel    = setImage("./img/txtbutton-cancel-game.png");
game.images.challenge = setImage("./img/txtbutton-challenge-game.png");
game.images.resume    = setImage("./img/txtbutton-resume.png");
game.images.back      = setImage("./img/button-back.png");
game.images.next      = setImage("./img/button-next.png");
game.images.help      = setImage("./img/txtbutton-how-to-play.png");

game.images.musicOn   = setImage("./img/sound-on.png");
game.images.musicOff  = setImage("./img/sound-off.png");
game.images.soundOn   = setImage("./img/speaker-on.png");
game.images.soundOff  = setImage("./img/speaker-off.png");


game.images.online = setImage("./img/txtbutton-online-game.png");
game.images.campaign = setImage("./img/txtbutton-campaign-game.png");
game.images.twoplayer = setImage("./img/txtbutton-two-player-game.png");

game.images.lock = setImage("./img/lock.png");
game.images.levelBorder = setImage("./img/level-border.png");

game.images.star = setImage("./img/star.png");



game.sounds = {};
game.stage = 1;

game.level = 0;
game.levels = [];

game.levels[0] = [];
game.levels[1] = [];
game.levels[2] = [];


game.levels[0][0] = { boardBack:0, boardWidth:3, boardHeight:3, board:[ [1,0,2],
														[0,0,0],
														[2,0,1] ]};

game.levels[0][1] = { boardBack:0, boardWidth:3, boardHeight:3, board:[ [1,0,2],
														[0,-1,0],
														[2,0,1] ]};
																												
game.levels[0][2] = { boardBack:0, boardWidth:1, boardHeight:7, board:[ [1,0,0,0,0,0,2]]};

game.levels[0][3] = { boardBack:0, boardWidth:4, boardHeight:4, board:[ [1,0,0,2],
														[0,-1,-1,0],
														[0,-1,-1,0],
														[2,0,0,1] ]};
														
game.levels[0][4] = { boardBack:0, boardWidth:4, boardHeight:4, board:[ [1,0,0,2],
														[-1,0,0,-1],
														[-1,0,0,-1],
														[2,0,0,1] ]};														

game.levels[0][5] = { boardBack:0, boardWidth:4, boardHeight:4, board:[ [1,-1,-1,2],
														[-1,0,0,-1],
														[-1,0,0,-1],
														[2,-1,-1,1] ]};
																												
game.levels[0][6] = { boardBack:0, boardWidth:5, boardHeight:5, board:[ [0,0,0,0,0],
														[0,-1,-1,-1,0],
														[0,-1,-1,-1,0],
														[0,-1,-1,-1,0],
														[2,-1,-1,-1,1] ]};	

game.levels[0][7] = { boardBack:0, boardWidth:5, boardHeight:5, board:[ [1,0,0,0,2],
														[0,0,0,0,0],
														[-1,-1,-1,-1,-1],
														[0,0,0,0,0],
														[2,0,0,0,1] ]};																												

game.levels[0][8] = { boardBack:0, boardWidth:5, boardHeight:5, board:[ [1,0,-1,0,2],
														[0,0,0,0,0],
														[-1,0,0,0,-1],
														[0,0,0,0,0],
														[2,0,-1,0,1] ]};	


game.levels[0][9] = { boardBack:0, boardWidth:5, boardHeight:5, board:[ [1,0,0,0,2],
														[0,0,-1,0,0],
														[0,-1,-1,-1,0],
														[0,0,-1,0,0],
														[2,0,0,0,1] ]};														

game.levels[0][10] = { boardBack:0, boardWidth:5, boardHeight:5, board:[ [1,0,0,0,2],
														[0,0,0,0,0],
														[0,0,0,0,0],
														[0,0,0,0,0],
														[2,0,0,0,1] ]};	
														
game.levels[0][11] = { boardBack:0, boardWidth:5, boardHeight:5, board:[ [1,0,-1,-1,-1],
														[0,0,0,-1,-1],
														[-1,0,0,0,-1],
														[-1,-1,0,0,0],
														[-1,-1,-1,0,2] ]};	
																																										
game.levels[0][12] = { boardBack:0, boardWidth:6, boardHeight:6, board:[ [1,0,0,0,0,2],
														[0,0,0,0,0,0],
														[0,-1,-1,-1,-1,0],
														[0,-1,-1,-1,-1,0],
														[0,0,0,0,0,0],
														[2,0,0,0,0,1] ]};	
														
game.levels[0][13] = { boardBack:0, boardWidth:6, boardHeight:6, board:[ [0,0,0,0,0,1],
														[0,-1,0,0,0,0],
														[0,0,-1,0,0,0],
														[0,0,0,-1,0,0],
														[0,0,0,0,-1,0],
														[2,0,0,0,0,0] ]};
														
game.levels[0][14] = { boardBack:0, boardWidth:6, boardHeight:6, board:[ [1,0,0,0,0,1],
														[0,0,0,0,0,0],
														[0,0,0,0,0,0],
														[0,0,0,0,0,0],
														[0,0,0,0,0,0],
														[2,0,0,0,0,2] ]};														
														
														
															
game.levels[1][0] = { boardBack:0, boardWidth:5, boardHeight:5, board:[ [1,0,-1,0,2],
														[0,0,-1,0,0],
														[-1,-1,0,-1,-1],
														[0,0,-1,0,0],
														[2,0,-1,0,1] ]};														

														
game.levels[1][1] = { boardBack:0, boardWidth:5, boardHeight:5, board:[ [0,-1,0,-1,0],
														[-1,-1,0,-1,-1],
														[1,0,0,0,2],
														[-1,-1,0,-1,-1],
														[0,-1,0,-1,0] ]};	

game.levels[1][2] = { boardBack:0, boardWidth:5, boardHeight:5, board:[ [1,0,0,0,2],
														[0,0,0,0,0],
														[-1,-1,-1,-1,-1],
														[0,0,0,0,0],
														[2,0,0,0,1] ]};																												

game.levels[1][3] = { boardBack:0, boardWidth:6, boardHeight:6, board:[ [1,0,0,0,0,2],
														[0,0,0,0,0,0],
														[0,0,0,0,0,0],
														[0,0,0,0,0,0],
														[0,0,0,0,0,0],
														[2,0,0,0,0,1] ]};	

game.levels[1][4] = { boardBack:0, boardWidth:6, boardHeight:6, board:[ [1,-1,0,0,-1,2],
														[-1,0,0,0,0,-1],
														[0,0,0,0,0,0],
														[0,0,0,0,0,0],
														[-1,0,0,0,0,-1],
														[2,-1,0,0,-1,1] ]};	
														
game.levels[1][5] = { boardBack:0, boardWidth:6, boardHeight:6, board:[ [1,0,0,0,0,2],
														[0,0,0,0,0,0],
														[0,0,-1,-1,0,0],
														[0,0,-1,-1,0,0],
														[0,0,0,0,0,0],
														[2,0,0,0,0,1] ]};	
game.levels[1][6] = { boardBack:0, boardWidth:6, boardHeight:6, board:[ [1,0,0,0,0,2],
														[0,0,0,0,0,0],
														[0,0,0,0,0,0],
														[0,0,0,0,0,0],
														[0,0,0,0,0,0],
														[2,0,0,0,0,1] ]};	

game.levels[1][7] = { boardBack:0, boardWidth:6, boardHeight:6, board:[ [1,-1,0,0,-1,2],
														[-1,0,0,0,0,-1],
														[0,0,0,0,0,0],
														[0,0,0,0,0,0],
														[-1,0,0,0,0,-1],
														[2,-1,0,0,-1,1] ]};	
														
game.levels[1][8] = { boardBack:0, boardWidth:6, boardHeight:6, board:[ [1,0,0,0,0,2],
														[0,0,0,0,0,0],
														[0,0,-1,-1,0,0],
														[0,0,-1,-1,0,0],
														[0,0,0,0,0,0],
														[2,0,0,0,0,1] ]};															
														
																											
game.levels[1][9] = { boardBack:0, boardWidth:7, boardHeight:7, board:[ [1,0,0,0,0,0,2],
														[0,0,0,0,0,0,0],
														[0,0,0,0,0,0,0],
														[0,0,0,0,0,0,0],
														[0,0,0,0,0,0,0],
														[0,0,0,0,0,0,0],
														[2,0,0,0,0,0,1] ]};
														
game.levels[1][10] = { boardBack:0, boardWidth:7, boardHeight:7, board:[ [1,0,0,-1,0,0,2],
														[0,0,0,-1,0,0,0],
														[0,0,0,-1,0,0,0],
														[-1,-1,-1,-1,-1,-1,-1],
														[0,0,0,-1,0,0,0],
														[0,0,0,-1,0,0,0],
														[2,0,0,-1,0,0,1] ]};	

game.levels[1][11] = { boardBack:0, boardWidth:7, boardHeight:7, board:[ [1,-1,-1,0,0,0,2],
														[-1,-1,0,0,0,0,-1],
														[-1,0,0,0,0,-1,-1],
														[0,0,0,0,-1,-1,-1],
														[-1,0,0,0,0,-1,-1],
														[-1,-1,0,0,0,0,-1],
														[2,-1,-1,0,0,0,1] ]};
														
game.levels[1][12] = { boardBack:0, boardWidth:7, boardHeight:7, board:[[1,0,-1,-1,-1,0,2],
														[0,0,-1,-1,-1,0,0],
														[0,0,-1,-1,-1,0,0],
														[0,0,-1,-1,-1,0,0],
														[0,0,-1,-1,-1,0,0],
														[0,0,0,0,0,0,0],
														[2,0,0,0,0,0,1] ]};
														
game.levels[1][13] = { boardBack:0, boardWidth:7, boardHeight:7, board:[[1,0,0,0,0,0,2],
														[0,0,0,0,0,0,0],
														[-1,-1,-1,-1,-1,-1,-1],
														[0,0,0,0,0,0,0],
														[-1,-1,-1,-1,-1,-1,-1],
														[0,0,0,0,0,0,0],
														[2,0,0,0,0,0,1] ]};
														
game.levels[1][14] = { boardBack:0, boardWidth:7, boardHeight:7, board:[[1,0,0,0,0,0,2],
														[0,-1,0,0,0,-1,0],
														[0,0,-1,-1,-1,0,0],
														[0,0,-1,0,-1,0,0],
														[0,0,-1,-1,-1,0,0],
														[0,-1,0,0,0,-1,0],
														[2,0,0,0,0,0,1] ]};																																										
														


														
game.levels[2][0] = { boardBack:0, boardWidth:6, boardHeight:6, board:[ [1,0,-1,0,0,1],
														[0,-1,0,-1,0,0],
														[-1,0,-1,0,-1,0],
														[0,-1,0,-1,0,-1],
														[0,0,-1,0,-1,0],
														[2,0,0,-1,0,2] ]};
														
game.levels[2][1] = { boardBack:0, boardWidth:6, boardHeight:6, board:[ [1,0,-1,-1,0,1],
														[0,-1,0,-1,-1,0],
														[0,0,0,0,-1,0],
														[0,-1,0,0,0,0],
														[0,-1,-1,0,-1,0],
														[2,0,-1,-1,0,2] ]};
																												
game.levels[2][2] = { boardBack:0, boardWidth:6, boardHeight:6, board:[ [1,0,0,0,0,1],
														[0,-1,0,-1,-1,0],
														[-1,0,0,0,-1,0],
														[0,-1,0,0,0,-1],
														[0,-1,-1,0,-1,0],
														[2,0,0,0,0,2] ]};													
														
game.levels[2][3] = { boardBack:0, boardWidth:7, boardHeight:7, board:[ [1,0,0,0,0,0,2],
														[0,-1,-1,-1,-1,-1,0],
														[0,-1,0,0,0,-1,0],
														[0,-1,0,0,0,-1,0],
														[0,-1,0,0,0,-1,0],
														[0,-1,-1,-1,-1,-1,0],
														[2,0,0,0,0,0,1] ]};
														
														
game.levels[2][4] = { boardBack:0, boardWidth:7, boardHeight:7, board:[ [1,0,0,0,0,0,2],
														[0,0,0,0,0,0,0],
														[0,0,0,0,0,0,0],
														[0,0,0,0,0,0,0],
														[0,0,0,0,0,0,0],
														[0,0,0,0,0,0,0],
														[2,0,0,0,0,0,1] ]};
														
game.levels[2][5] = { boardBack:0, boardWidth:7, boardHeight:7, board:[ [0,0,0,1,0,0,0],
														[-1,0,0,0,0,0,-1],
														[-1,-1,0,0,0,-1,-1],
														[-1,-1,-1,0,-1,-1,-1],
														[-1,-1,0,0,0,-1,-1],
														[-1,0,0,0,0,0,-1],
														[0,0,0,2,0,0,0] ]};

game.levels[2][6] = { boardBack:0, boardWidth:7, boardHeight:7, board:[ [1,0,0,0,0,0,2],
														[0,0,0,0,0,0,0],
														[0,0,0,0,0,0,0],
														[0,0,0,0,0,0,0],
														[0,0,0,0,0,0,0],
														[0,0,0,0,0,0,0],
														[2,0,0,0,0,0,1] ]};

game.levels[2][7] = { boardBack:0, boardWidth:7, boardHeight:7, board:[ [1,-1,0,-1,0,-1,2],
														[-1,0,-1,0,-1,0,-1],
														[0,-1,0,-1,0,-1,0],
														[-1,0,-1,0,-1,0,-1],
														[0,-1,0,-1,0,-1,0],
														[-1,0,-1,0,-1,0,-1],
														[2,-1,0,-1,0,-1,1] ]};																																																								
														
game.levels[2][8] = { boardBack:0, boardWidth:7, boardHeight:7, board:[ [0,0,0,1,0,0,0],
														[-1,-1,-1,-1,-1,-1,-1],
														[0,0,0,0,0,0,0],
														[-1,-1,-1,-1,-1,-1,-1],
														[0,0,0,0,0,0,0],
														[-1,-1,-1,-1,-1,-1,-1],
														[0,0,0,2,0,0,0] ]};
														
game.levels[2][9] = { boardBack:0, boardWidth:7, boardHeight:7, board:[ [1,0,0,-1,0,0,2],
														[0,0,0,-1,0,0,0],
														[0,0,0,-1,0,0,0],
														[-1,-1,-1,-1,-1,-1,-1],
														[0,0,0,-1,0,0,0],
														[0,0,0,-1,0,0,0],
														[2,0,0,-1,0,0,1] ]};	

game.levels[2][10] = { boardBack:0, boardWidth:7, boardHeight:7, board:[ [1,-1,-1,0,0,0,2],
														[-1,-1,0,0,0,0,-1],
														[-1,0,0,0,0,-1,-1],
														[0,0,0,0,-1,-1,-1],
														[-1,0,0,0,0,-1,-1],
														[-1,-1,0,0,0,0,-1],
														[2,-1,-1,0,0,0,1] ]};
														
game.levels[2][11] = { boardBack:0, boardWidth:7, boardHeight:7, board:[[1,0,-1,-1,-1,0,2],
														[0,0,-1,-1,-1,0,0],
														[0,0,-1,-1,-1,0,0],
														[0,0,-1,-1,-1,0,0],
														[0,0,-1,-1,-1,0,0],
														[0,0,0,0,0,0,0],
														[2,0,0,0,0,0,1] ]};
														
game.levels[2][12] = { boardBack:0, boardWidth:7, boardHeight:7, board:[[1,0,0,0,0,0,2],
														[0,0,0,0,0,0,0],
														[-1,-1,-1,-1,-1,-1,-1],
														[0,0,0,0,0,0,0],
														[-1,-1,-1,-1,-1,-1,-1],
														[0,0,0,0,0,0,0],
														[2,0,0,0,0,0,1] ]};
														
game.levels[2][13] = { boardBack:0, boardWidth:7, boardHeight:7, board:[[1,0,0,0,0,0,2],
														[0,-1,0,0,0,-1,0],
														[0,0,-1,-1,-1,0,0],
														[0,0,-1,0,-1,0,0],
														[0,0,-1,-1,-1,0,0],
														[0,-1,0,0,0,-1,0],
														[2,0,0,0,0,0,1] ]};																																										


game.levels[2][14] = { boardBack:0, boardWidth:7, boardHeight:7, board:[[1,0,0,0,0,0,2],
														[0,0,0,0,-1,0,0],
														[0,-1,0,0,0,-1,0],
														[0,0,0,-1,0,-1,0],
														[0,-1,0,0,0,-1,0],
														[0,0,0,0,-1,0,0],
														[2,0,0,0,0,0,1] ]};															